#
# BEGIN COPYRIGHT BLOCK
# Copyright (C) 2001 Sun Microsystems, Inc.  Used by permission.
# Copyright (C) 2005 Red Hat, Inc.
# All rights reserved.
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation version
# 2.1 of the License.
#                                                                                  
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#                                                                                  
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# END COPYRIGHT BLOCK
#
#
# These are the default values 
#
# Individual modules may override them
#
# BUILD_BOMB=[-DPUMPKIN_HOUR=xxxxxxx or just leave it empty]
# BUILD_DEBUG=[full, optimize, purify]
# BUILD_MODULE=[HTTP_ADMIN, HTTP_PERSONAL, HTTP_ENTERPRISE, ...]
# BUILD_SECURITY=[none, export, domestic]

ABS_ROOT := $(shell cd $(BUILD_ROOT); pwd)
ABS_ROOT_PARENT := $(shell cd $(ABS_ROOT)/..; pwd)
RELTOOLSPATH = $(ABS_ROOT_PARENT)/reltools

TMP_ARCH := $(shell uname -s)
RELEASE := $(shell uname -r)
ifeq ($(TMP_ARCH), WINNT)
BUILD_ARCH := $(shell uname -s)
else
BUILD_ARCH := $(shell $(ABS_ROOT)/nsarch)
endif

NSOS_TEST1 := $(shell uname -m)

PKG_ARCH=$(BUILD_ARCH)

PUMPKIN_AGE := 90
BUILD_BOMB=
#BUILD_BOMB=-DPUMPKIN_HOUR=$(shell cat $(ABS_ROOT)/pumpkin.dat)
BUILD_CHECKER=no
BUILD_DEBUG=full
BUILD_MODULE=HTTP_ADMIN
BUILD_NSPR_THREADS=yes
BUILD_SECURITY=domestic
ifeq ($(USE_PTHREADS), 1)
  ifeq ($(USE_N32), 1)
     BUILD_PTHREADS=-n32-pth
  else
     BUILD_PTHREADS=-pth
  endif
else
  BUILD_PTHREADS=
endif

ifeq ($(USE_64), 1)
  NS64TAG = _64
else
  ifeq ($(BUILD_ARCH), HPUX)
	ifeq ($(NSOS_TEST1),ia64)
	  NS64TAG=_32
	endif
  endif
endif

PRETTY_ARCH := $(shell uname -s)
 
NSOS_ARCH         := $(subst /,_,$(shell uname -s))

ifeq ($(NSOS_ARCH), Linux)
  NSOS_TEST := $(shell cat /etc/redhat-release)
  ifeq ($(findstring Taroon, $(NSOS_TEST)),Taroon)
    NSOS_ARCH := RHEL
    NSOS_RELEASE := 3
    # Always use gcc on RHEL
    GCC_VERSION := gcc$(word 1, $(shell gcc --version | sed 's/gcc.*GCC.\s//' |sed 's/\..*//'))
  else
    ifeq ($(findstring Nahant, $(NSOS_TEST)),Nahant)
      NSOS_ARCH := RHEL
      NSOS_RELEASE := 4
      # Always use gcc on RHEL
      GCC_VERSION := gcc$(word 1, $(shell gcc --version | sed 's/gcc.*GCC.\s//' | sed 's/\..*//'))
    endif
  endif
endif
  
ifeq ($(NSOS_ARCH),WINNT)
LIB_SUFFIX = lib
else
LIB_SUFFIX = a
endif
    
ifeq ($(NSOS_ARCH), AIX)
NSOS_TEST        := $(shell uname -v)
ifeq ($(NSOS_TEST),3)
NSOS_RELEASE   := $(shell uname -r)
else
NSOS_RELEASE   := $(shell uname -v).$(shell uname -r)
endif
else
ifneq ($(NSOS_ARCH), RHEL)
NSOS_RELEASE      := $(shell uname -r)
endif

#
# Handle FreeBSD 2.2-STABLE and Linux 2.0.30-osfmach3 and 2.2.14-5.0smp
#

ifeq (,$(filter-out Linux FreeBSD,$(NSOS_ARCH)))
  NSOS_RELEASE  := $(shell echo $(NSOS_RELEASE) | sed 's/-.*//')
endif
ifeq ($(NSOS_ARCH), Linux)
NSOS_RELEASE      := $(basename $(NSOS_RELEASE))
endif
endif

# Get OSF's OS revision number to figure out the OS release
ifeq ($(NSOS_ARCH),OSF1)
  NSOS_RELEASE1      := $(shell uname -r)
  NSOS_OSF1REV       := $(shell uname -v)
  ifeq ($(NSOS_OSF1REV),878)
    NSOS_RELEASE := $(NSOS_RELEASE1)D
  else
    ifeq ($(NSOS_OSF1REV),564)
      NSOS_RELEASE := $(NSOS_RELEASE1)B
    else
      ifeq ($(NSOS_OSF1REV),464)
        NSOS_RELEASE := $(NSOS_RELEASE1)A
      else
        NSOS_RELEASE := $(NSOS_RELEASE1)
      endif
    endif
  endif
endif

ifeq ($(NSOS_ARCH), SunOS)
  ifeq ($(shell uname -m), i86pc)
    NSOS_MACHINE := _i86pc
  endif
endif

NSPLATFORM_ID = $(NSOS_ARCH)$(NSOS_RELEASE)$(NSOS_MACHINE)$(NS64TAG)

ifneq ($(NO_BUILD_NUM), true)
GET_BUILD_NUM := $(shell cat $(ABS_ROOT)/$(NSPLATFORM_ID)/buildnum.dat)
endif

ifdef REL_BUILD
INTGBUILD=0
else
INTGBUILD=1
endif

ifeq ($(BUILD_ARCH), WINNT)
  BUILD_DLL_VERSION=yes
  BUILD_HTTPDLL_NAME=ns-httpd30
  BUILD_ADMIN_NAME=ns-admin40
  PERL_ARCH=$(shell uname -p)
  PERL=perl

  ZIP_ROOT=$(ABS_ROOT)/infozip
  PROCESSOR:=$(shell uname -p)
  ifeq ($(PROCESSOR), I386)
    ZIPDIR=$(ZIP_ROOT)/i386
  else
    ifeq ($(PROCESSOR), MIPS)
      ZIPDIR=$(ZIP_ROOT)/mips
    else
      ifeq ($(PROCESSOR), ALPHA)
        ZIPDIR=$(ZIP_ROOT)/alpha
      else
        ZIP_DIR=$(PROCESSOR)-is-not-supported-for-processor
      endif
    endif
  endif

  ZIP=$(ZIPDIR)/zip.exe
  UNZIP = $(ZIPDIR)/unzip.exe -o

else
  ifeq ($(BUILD_ARCH), Linux)
#PERL=$(COMPONENTS_DIR)/perl5/$(PKG_ARCH)2.1-perl5/perl
    PERL=perl
  else
	NSPERL_RELDATE :=20020626
    PERL=/share/builds/sbstools/nsPerl/$(NSPERL_RELDATE)/$(NSOBJDIR_NAME_32)/nsperl
  endif
  ZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/zip
  UNZIP = $(COMPONENTS_DIR)/infozip/$(PKG_ARCH)/unzip -o
  IZIP  = $(ZIP) -ry9uT
endif


define echo_build_parms
echo ==== Building with the following parameters ====
echo BUILD_ARCH=$(BUILD_ARCH) 
echo BUILD_MODULE=$(BUILD_MODULE)
echo BUILD_SECURITY=$(BUILD_SECURITY)
echo BUILD_DEBUG=$(BUILD_DEBUG)
echo BUILD_NSPR_THREADS=$(BUILD_NSPR_THREADS)
echo BUILD_BOMB=$(BUILD_BOMB)
echo BUILD_DLL_VERSION=$(BUILD_DLL_VERSION)
echo BUILD_HTTPDLL_NAME=$(BUILD_HTTPDLL_NAME)
echo BUILD_ADMIN_NAME=$(BUILD_ADMIN_NAME)
echo BUILD_CHECKER=$(BUILD_CHECKER)
echo BUILD_IIOPLIB=$(BUILD_IIOPLIB)
endef

#
# Set up these names because most of the makefiles use them now.
#
ARCH=$(BUILD_ARCH)
SECURITY=$(BUILD_SECURITY)
DEBUG=$(BUILD_DEBUG)
BOMB=$(BUILD_BOMB)
NSPR_THREADS=$(BUILD_NSPR_THREADS)
BUILD_DLL=$(BUILD_DLL_VERSION)
ADMINDLL_NAME=$(BUILD_ADMIN_NAME)
HTTPDLL_NAME=$(BUILD_HTTPDLL_NAME)
BOUNDS_CHECKER=$(BUILD_CHECKER)
RESOLV_FLAG=
DO_SEARCH=
NODE_FLAG=-DNO_NODELOCK

MAJOR_VERSION:="1"
MINOR_VERSION:="0"
ADMSDK_VERSION:=1.0
LDAP_NO_LIBLCACHE:=1

DIRVERDIR=$(COMMON_OBJDIR)/include
DIRVER_H=$(DIRVERDIR)/dirver.h

#
# -- Default Section --------------------------------------------------------
#
# Some of the _OBJDIR is maintained for backward compatibility until they
# are all cleaned up.  
#

ifndef OBJDIR
OBJDIR=$(ABS_ROOT)/built/$(FULL_RTL_OBJDIR)
endif

ifndef COMMON_OBJDIR
COMMON_OBJDIR=$(OBJDIR)
endif

ifndef ADMSERV_OBJDIR
ADMSERV_OBJDIR=$(OBJDIR)
endif
